# This file is a template, and might need editing before it works on your project.
# Official docker image.
image: docker:latest

services:
  - docker:dind

before_script:
  - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY

build-develop:
  stage: build
  script:
    - docker build --build-arg PDCI_COMMIT_SHA=${CI_COMMIT_SHA} --build-arg PDCI_COMMIT_REF_NAME=${CI_COMMIT_REF_NAME} --build-arg PDCI_COMMIT_SHORT_SHA=${CI_COMMIT_SHORT_SHA} --build-arg PDCI_COMMIT_TAG=${CI_COMMIT_TAG} --no-cache --pull --target develop -t "$CI_REGISTRY_IMAGE:develop" .
    - docker image inspect  "$CI_REGISTRY_IMAGE:develop"
    - docker push "$CI_REGISTRY_IMAGE:develop"
  only:
    - develop

#build-local:
#  stage: build
#  script:
#    - docker build --build-arg PDCI_COMMIT_SHA=${CI_COMMIT_SHA} --build-arg PDCI_COMMIT_REF_NAME=${CI_COMMIT_REF_NAME} --build-arg PDCI_COMMIT_SHORT_SHA=${CI_COMMIT_SHORT_SHA} --build-arg PDCI_COMMIT_TAG=${CI_COMMIT_TAG} --no-cache --pull --target develop -t "$CI_REGISTRY_IMAGE:local" .
#    - docker image inspect  "$CI_REGISTRY_IMAGE:local"
#    - docker push "$CI_REGISTRY_IMAGE:local"
#  only:
#    - develop

build-develop-sql:
  stage: build
  script:
    - docker build --no-cache --pull --target sql -t "$CI_REGISTRY_IMAGE/image_file_sql:develop" .
    - docker push  "$CI_REGISTRY_IMAGE/image_file_sql:develop"
  only:
    - develop

build-master:
  stage: build
  script:
    - docker build --build-arg PDCI_COMMIT_SHA=${CI_COMMIT_SHA} --build-arg PDCI_COMMIT_REF_NAME=${CI_COMMIT_REF_NAME} --build-arg PDCI_COMMIT_SHORT_SHA=${CI_COMMIT_SHORT_SHA} --build-arg PDCI_COMMIT_TAG=${CI_COMMIT_TAG} --no-cache --pull --target build -t "$CI_REGISTRY_IMAGE:build" .
    - docker build --build-arg PDCI_COMMIT_SHA=${CI_COMMIT_SHA} --build-arg PDCI_COMMIT_REF_NAME=${CI_COMMIT_REF_NAME} --build-arg PDCI_COMMIT_SHORT_SHA=${CI_COMMIT_SHORT_SHA} --build-arg PDCI_COMMIT_TAG=${CI_COMMIT_TAG} --no-cache --pull --target production -t "$CI_REGISTRY_IMAGE:master" .
    - docker image inspect  "$CI_REGISTRY_IMAGE:master"
    - docker push "$CI_REGISTRY_IMAGE:master"
  only:
    - master

build-feature:
  stage: build
  script:
    - export
    - docker build --build-arg PDCI_COMMIT_SHA=${CI_COMMIT_SHA} --build-arg PDCI_COMMIT_REF_NAME=${CI_COMMIT_REF_NAME} --build-arg PDCI_COMMIT_SHORT_SHA=${CI_COMMIT_SHORT_SHA} --build-arg PDCI_COMMIT_TAG=${CI_COMMIT_TAG} --no-cache --pull --target develop -t "$CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG" .
    - docker image inspect  "$CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG"
    - docker push "$CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG"
  only:
    - branches
  except:
    - develop
    - master

build-feature-sql:
  stage: build
  script:
    - docker build --no-cache --pull --target sql -t "$CI_REGISTRY_IMAGE/image_file_sql:$CI_COMMIT_REF_SLUG" .
    - docker push  "$CI_REGISTRY_IMAGE/image_file_sql:$CI_COMMIT_REF_SLUG"
  only:
    - branches
  except:
    - develop
    - master

build-tag:
  stage: build
  script:
    - docker build --build-arg PDCI_COMMIT_SHA=${CI_COMMIT_SHA} --build-arg PDCI_COMMIT_REF_NAME=${CI_COMMIT_REF_NAME} --build-arg PDCI_COMMIT_SHORT_SHA=${CI_COMMIT_SHORT_SHA} --build-arg PDCI_COMMIT_TAG=${CI_COMMIT_TAG} --no-cache --pull --target build -t "$CI_REGISTRY_IMAGE:build" .
    - docker build --build-arg PDCI_COMMIT_SHA=${CI_COMMIT_SHA} --build-arg PDCI_COMMIT_REF_NAME=${CI_COMMIT_REF_NAME} --build-arg PDCI_COMMIT_SHORT_SHA=${CI_COMMIT_SHORT_SHA} --build-arg PDCI_COMMIT_TAG=${CI_COMMIT_TAG} --no-cache --pull --target production -t "$CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG" .
    - docker image inspect  "$CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG"
    - docker push "$CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG"
  only:
    - tags
  except:
    - master